package main

import (
	"fmt"
	"time"
)

//             12345678
const Niter = 10000000

const BufSize = 4*1024*1024
var buf  [BufSize]byte
var buf2 [BufSize]byte

func main() {
	for size := 0; size <= BufSize; {
		src := buf[:size]
		dst := buf2[:size]

		// warmup
		copy(dst, src)

		Tstart := time.Now()

		niter := Niter
		if (size > 1E4) {
			niter /= (size / 1E3)
		}

		//for i := 0; i < Niter; i++ {
		for i := 0; i < niter; i++ {
			copy(dst, src)
		}

		Tend := time.Now()

		fmt.Printf("%v\t%.1f\n", size, float64(Tend.Sub(Tstart).Nanoseconds()) / float64(niter))

		switch {
		case size < 256:
			size += 1	// detailed start
		case size < 32*1024:
			size += 128
		case size < 1024*1024:
			size += 512
		default:
			size += 1024
		}
	}
}
